#!perl -w

#===============================================================================
# Ɛӎ
# {package𗘗pƂŐSĂ̌ʂɑ΂쐬҂͐ӂ𕉂܂B
#===============================================================================
package HandleOleExcel;
use Win32::OLE;
use Image::Size;
use File::Basename;
use Encode qw(decode encode);
use Carp;
use warnings;
use strict;

# ==============================================================================
# Class/Namespace VersionݒBOɌ̂our`B
our $VERSION = '0.09';
# ==============================================================================
# 
# 0.09: 2023/05/05: getStrDatWorksheetǉ
# 0.08: 2023/04/23: get/setValCurrentRegion̖OtWC
# 0.07: 2023/04/16: createExcelFileǉ, getInfoNamedRange
# 0.06: 2023/04/10: getInfoNamedRange, copyWorksheetAltǉ
#                 : OtWݎΉ
#                 : addWorksheetV[g`FbNoOC
#                 : getValWorksheetیV[gΉ
# 0.05: 2023/04/02: get_dim_value_of_range֐(private)ǉ
# 0.04: 2023/04/01: clearContentsRange\bhǉ
# 0.03: 2023/03/29: copyWorksheet\bhǉ
# 0.02: 2023/03/28: addWorksheet\bhǉ
#                 : removeWorksheet\bhǉ
#                 : setShapeRange\bhǉ
# 0.01: 2022/01/23: s
# ==============================================================================

# ==============================================================================
# IvVݒnbV(Class/NamespaceCX^XԋL)
# OɒڌȂBݒsetOtion\bhoR
# ==============================================================================
my %_G_Set;
  # IvVݒ(msg): ʏ탁bZ[W
  #   0: \Ȃ (ftHg)
  #   1: bZ[W\
    $_G_Set{msg} = 0;
  # ---------------------------------------------------------------------------
  # IvVݒ(warn): Warning/ErrorbZ[W
  #   0: undef߂
  #   1: undef߂ + bZ[W\
  #   2: undef߂ + bZ[W\ + carp (ftHg)
  #   3: undef߂ + bZ[W\ + croak
    $_G_Set{warn} = 1;
  # ---------------------------------------------------------------------------
  # IvVݒ(warn_ole): Win32::OLEG[bZ[W
  #   0: \}~ (ftHg)
  #   0ȊO̐ݒɂĂ͉LQ
  #     https://metacpan.org/release/JDB/Win32-OLE-0.1709/view/lib/Win32/OLE.pm#Warn
    $_G_Set{warn_ole} = 0;
  # ---------------------------------------------------------------------------
  # IvVݒ(overwrite): File copy/SaveAs[h
  #   0: ㏑Rs[֎~
  #   1: ㏑Rs[ (ftHg)
    $_G_Set{overwrite} = 1;

# ==============================================================================
# ConstƂĎgpϐ`
# ==============================================================================
  # VBA Enum
    my $_G_xlCellTypeLastCell = 11; # XlCellType  xlCellTypeLastCell Enuml
    my $_G_msoFalse =  0;           # MsoTriState  msoFalse Enuml
    my $_G_msoTrue  = -1;           # MsoTriState  msoTrue  Enuml
    my $_G_msoShapeRectangle = 1;   # MsoAutoShapeType  msoShapeRectangle Enuml
    my $_G_msoShapeOval = 9;        # MsoAutoShapeType  msoShapeOval      Enuml
  
  # ݒf[^ʔr
    my $_G_Sc_Cs_Ms =  0; # cur(scalar) / mod(scalar)
    my $_G_Sc_Cs_M1 =  1; # cur(scalar) / mod(1-dim)
    my $_G_Sc_Cs_M2 =  2; # cur(scalar) / mod(2-dim)
    my $_G_Sc_C1_Ms = 10; # cur(1-dim)  / mod(scalar)
    my $_G_Sc_C1_M1 = 11; # cur(1-dim)  / mod(1-dim)
    my $_G_Sc_C2_Ms = 20; # cur(2-dim)  / mod(scalar)
    my $_G_Sc_C2_M2 = 21; # cur(2-dim)  / mod(2-dim)
    my $_G_Sc_Cu_Ms = 30; # cur(undef)  / mod(scalar)
    my $_G_Sc_Cu_M1 = 31; # cur(undef)  / mod(1-dim)
    my $_G_Sc_Cu_M2 = 32; # cur(undef)  / mod(2-dim)


# ==============================================================================
# w背WɂnbVf[^߂
# ߂l: undef(s) / nbVt@X()
# ==============================================================================
sub getStrDatWorksheet {
  # 擪̃IuWFNg擾
    my ($obj) = shift(@_);
  
  # Ot`
    my %defaults = (
        sheet => '',  # worksheet
        range => '',  # range
        mode  => 'c'  # c(col)/r(row)/c_r(col_row)/r_c(row_col)
    );
    
  # ݒ
    my %args = (%defaults, @_);
    
  # e`FbN
    unless ($args{sheet} ne '') {
        $obj->error_msg("Argument 'sheet' is mandatory.");
        return undef;
    }
    unless ($args{range} ne '') {
        $obj->error_msg("Argument 'range' is mandatory.");
        return undef;
    }
    unless ($args{range} !~ /:/) {
        $obj->error_msg("Argument 'range' allows only single cell address.");
        return undef;
    }
    $args{mode} =~ lc($args{mode}); # 
    unless (($args{mode} eq 'c') or ($args{mode} eq 'r') or ($args{mode} eq 'c_r') or ($args{mode} eq 'r_c')) {
        $obj->error_msg("Argument 'mode' allows only 'c', 'r', 'c_r' or 'r_c'.");
        return undef;
    }
    
  # IuWFNg擾
    my $book  = get_book_obj($obj);                        return undef unless ($book);
    my $sheet = get_sheet_obj($obj, $book, $args{sheet});  return undef unless ($sheet);
    my $range = get_range_obj($obj, $sheet, $args{range}); return undef unless ($range);
    
  # Left-topZindex擾
    my $left_top_addr = $args{range};
    my $left_top_row = $range->{Row} -1;
    my $left_top_col = $range->{Column} -1;
  
  # UsedRangeAhX擾
    my $used_range_addr = $sheet->UsedRange()->Address();
    
  # Right-bottomZAhX擾
    my $right_bottom_addr = '';
    if ($used_range_addr =~ /\s*(\S+):(\S+)\s*$/) { # Z
        $right_bottom_addr = $2;
    }
    elsif ($used_range_addr =~ /\s*(\S+)\s*$/) {    # PZ
        $right_bottom_addr = $1;
    }
    else {
        $obj->error_msg("'$args{sheet}' does not have any value.");
        return undef;
    }
    
  # Right-bottomZindex擾
    my $right_bottom_range = get_range_obj($obj, $sheet, $right_bottom_addr); return undef unless ($right_bottom_range);
    my $right_bottom_row = $right_bottom_range->{Row} -1;
    my $right_bottom_col = $right_bottom_range->{Column} -1;
    
  # Left-top/Right-bottomZindexr
    unless (($right_bottom_row > $left_top_row) and ($right_bottom_col > $left_top_col)) {
        $obj->error_msg("'$args{range}' would be illegal for the address of the base cell." );
        return undef;
    }
  
  # ΏۃWAhX쐬ƒl擾
    my $table_range_addr = '$A$1'.':'.$right_bottom_addr; # l擾Ώۂ̓[NV[g̑SZ
    my $table_range = get_range_obj($obj, $sheet, $table_range_addr); return undef unless ($table_range);
    my $table_vals  = $table_range->{Value}; # K2Xgt@X
  
  # TagW
    my $ctags;
    for (my $c=$left_top_col; $c<=$right_bottom_col; $c++) {
        if (defined($table_vals->[$left_top_row]->[$c])) {
            my $ctag = $table_vals->[$left_top_row]->[$c];
            my $ctag_utf8 = decode('cp932', $ctag);
            $ctags->{cp932}->{$ctag}->{r} = $left_top_row;
            $ctags->{cp932}->{$ctag}->{c} = $c;
            $ctags->{utf8}->{$ctag_utf8}->{r} = $left_top_row;
            $ctags->{utf8}->{$ctag_utf8}->{c} = $c;
        }
        
    }
    
  # sTagW
    my $rtags;
    for (my $r=$left_top_row; $r<=$right_bottom_row; $r++) {
        if (defined($table_vals->[$r]->[$left_top_col])) {
            my $rtag = $table_vals->[$r]->[$left_top_col];
            my $rtag_utf8 = decode('cp932', $rtag);
            $rtags->{cp932}->{$rtag}->{r} = $r;
            $rtags->{cp932}->{$rtag}->{c} = $left_top_col;
            $rtags->{utf8}->{$rtag_utf8}->{r} = $r;
            $rtags->{utf8}->{$rtag_utf8}->{c} = $left_top_col;
        }
        
    }
    
  # \f[^쐬
    my $ret = undef;
    if ($args{mode} eq 'c') {
        foreach my $ctag_utf8 (keys(%{$ctags->{utf8}})) {
            my $ctag_cp932 = encode('cp932', $ctag_utf8);
            my $i=0;
            my $c=$ctags->{utf8}->{$ctag_utf8}->{c};
            for (my $r=$ctags->{utf8}->{$ctag_utf8}->{r}+1; $r<=$right_bottom_row; $r++) {
                if (defined($table_vals->[$r]->[$c])) {
                    my $val_cp932 = $table_vals->[$r]->[$c];
                    my $val_utf8 = decode('cp932', $val_cp932);
                    $ret->{cp932}->{$ctag_cp932}->[$i] = $val_cp932;
                    $ret->{utf8}->{$ctag_utf8}->[$i] = $val_utf8;
                }
                else {
                    $ret->{cp932}->{$ctag_cp932}->[$i] = undef;
                    $ret->{utf8}->{$ctag_utf8}->[$i] = undef;
                }
                $i++;
            }
        }
    }
    elsif ($args{mode} eq 'r') {
        foreach my $rtag_utf8 (keys(%{$rtags->{utf8}})) {
            my $rtag_cp932 = encode('cp932', $rtag_utf8);
            my $i=0;
            my $r=$rtags->{utf8}->{$rtag_utf8}->{r};
            for (my $c=$rtags->{utf8}->{$rtag_utf8}->{c}+1; $c<=$right_bottom_col; $c++) {
                if (defined($table_vals->[$r]->[$c])) {
                    my $val_cp932 = $table_vals->[$r]->[$c];
                    my $val_utf8 = decode('cp932', $val_cp932);
                    $ret->{cp932}->{$rtag_cp932}->[$i] = $val_cp932;
                    $ret->{utf8}->{$rtag_utf8}->[$i] = $val_utf8;
                }
                else {
                    $ret->{cp932}->{$rtag_cp932}->[$i] = undef;
                    $ret->{utf8}->{$rtag_utf8}->[$i] = undef;
                }
                $i++;
            }
        }
    }
    elsif (($args{mode} eq 'r_c') or ($args{mode} eq 'c_r')) {
        foreach my $rtag_utf8 (keys(%{$rtags->{utf8}})) {
            my $rtag_cp932 = encode('cp932', $rtag_utf8);
            my $r = $rtags->{utf8}->{$rtag_utf8}->{r};
            foreach my $ctag_utf8 (keys(%{$ctags->{utf8}})) {
                my $ctag_cp932 = encode('cp932', $ctag_utf8);
                my $c = $ctags->{utf8}->{$ctag_utf8}->{c};
                if (($r>$left_top_row) and ($c>$left_top_col)) {
                    if (defined($table_vals->[$r]->[$c])) {
                        my $val_cp932 = $table_vals->[$r]->[$c];
                        my $val_utf8 = decode('cp932', $val_cp932);
                        if ($args{mode} eq 'r_c') {
                            $ret->{cp932}->{$rtag_cp932}->{$ctag_cp932} = $val_cp932;
                            $ret->{utf8}->{$rtag_utf8}->{$ctag_utf8} = $val_utf8;
                        }
                        elsif ($args{mode} eq 'c_r') {
                            $ret->{cp932}->{$ctag_cp932}->{$rtag_cp932} = $val_cp932;
                            $ret->{utf8}->{$ctag_utf8}->{$rtag_utf8} = $val_utf8;
                        }
                    }
                    else {
                        if ($args{mode} eq 'r_c') {
                            $ret->{cp932}->{$rtag_cp932}->{$ctag_cp932} = undef;
                            $ret->{utf8}->{$rtag_utf8}->{$ctag_utf8} = undef;
                        }
                        elsif ($args{mode} eq 'c_r') {
                            $ret->{cp932}->{$ctag_cp932}->{$rtag_cp932} = undef;
                            $ret->{utf8}->{$ctag_utf8}->{$rtag_utf8} = undef;
                        }
                    }
                }
            }
        }
    }
    
    return $ret;
}

# ==============================================================================
# w薼Excelt@C쐬B
# ߂l: undef(s) / 1()
# ==============================================================================
sub createExcelFile {
    my ($obj, $excel_file_name) = @_;
    
  # OpenĂExcelt@C͖
    unless ($obj->{excel_file_name} eq '') {
        $obj->error_msg("The instance has already opened '$obj->{excel_file_name}'."); return undef;
    }
    
  # wt@C݂͑Ȃ
    if (-f $excel_file_name) {
        $obj->error_msg("Excel file '$excel_file_name' already exists.");
        return undef;
    }
  
  # PCExcel
    my $objExcel = Win32::OLE->new('Excel.Application');
    unless ($objExcel) {
        $obj->error_msg("Excel OLE object has not been got. (Excel would not be installed.)"); return undef;
    }
  
  # ExcelOpen͐΃pXKvȂ̂FSOGetAbsolutePathNameŕϊ
  # ̓G[
    my $objFso = Win32::OLE->new('Scripting.FileSystemObject');
    my $excel_file_name_full = $objFso->GetAbsolutePathName($excel_file_name);
    $objFso = undef; # FSO
    
  # ΃pXtH_擾
    my $folder_name = File::Basename::dirname($excel_file_name_full);
    
  # wtH_݂͑
    unless (-d $folder_name) {
        $obj->error_msg("Folder '$folder_name' is not found."); return undef;
    }
    
  # WorkbookAdd
    my $objBook = $objExcel->Workbooks->Add();
    unless ($objBook) {
        $obj->error_msg("Excel can not create new workbook."); return undef;
    }
    
  # 擾BookIuWFNgŎwt@CɂSaveAs邱ƂŎ̃t@C쐬
    my $ret_save = $objBook->SaveAs($excel_file_name_full);
    unless ($objBook) {
        $obj->error_msg("Excel can not create new workbook '$excel_file_name'."); return undef;
    }
    $obj->msg("File '$excel_file_name' is created.");
    
  # BookIuWFNg擾łAeoϐɓ
  # LoϐClassŎQƂ
    $obj->{excel_file_name} = $excel_file_name; # Excelt@C
    $obj->{obj_excel} = $objExcel;              # Excel Application
    $obj->{obj_book}  = $objBook;               # Excel Book
    
  # I
    return 1;
}

# ==============================================================================
# w背W̃RecNA(OtWΉ)
# ߂l: undef(s) / 1()
# ==============================================================================
sub clearContentsRange {
  # 擪̃IuWFNg擾
    my ($obj) = shift(@_);
  
  # Ot`
    my %defaults = (
        sheet => '',  # worksheet
        range => ''   # range
    );
  
  # ݒ
    my %args = (%defaults, @_);
    
  # IuWFNg擾
    my $book  = get_book_obj($obj);                        return undef unless ($book);
    my $sheet = get_sheet_obj($obj, $book, $args{sheet});  return undef unless ($sheet);
    my $range = get_range_obj($obj, $sheet, $args{range}); return undef unless ($range);
  
  # NARec
    $range->ClearContents();
  
  # I
    return 1;
}

# ==============================================================================
# w薼̃[NV[g폜
# ߂l: undef(s) / 1()
# ==============================================================================
sub removeWorksheet {
    my ($obj, $remove_name) = @_;
    
  # bookIuWFNg擾
    my $book = get_book_obj($obj); return undef unless ($book);
  
  # worksheetXg擾
    my $sheet_list = getListWorksheets($obj);
  
  # 폜ΏۃV[g݂͑
    my $found = 0;
    foreach my $sheet_name (@{$sheet_list}) {
        if ($remove_name eq $sheet_name) { $found = 1; last; }
    }
    unless ($found) { $obj->error_msg("$remove_name does not exist."); return undef; }
  
  # ApplicationIuWFNg擾
    my $application = $obj->{obj_excel};
    
  # worksheet폜Alert}
    $application->{DisplayAlerts} = 0; # False
    
  # worksheetIuWFNg擾
    my $sheet = get_sheet_obj($obj, $book, $remove_name);
  
  # worksheet폜
    $sheet->Delete();
    
  # worksheet폜AlertA
    $application->{DisplayAlerts} = 1; # True
  
  # I
    $obj->msg("Worksheet '$remove_name' is removed.");
    return 1;
}

# ==============================================================================
# w薼̃[NV[gCopy(ی삳ꂽV[g̃Rs[)
# ߂l: undef(s) / Rs[ǉV[gIuWFNg()
# ==============================================================================
sub copyWorksheetAlt {
  # 擪̃IuWFNgshiftŎ擾
    my $obj = shift(@_);
    
  # Ot`+ftHgݒ
    my %defaults = (
        base  => '',  # x[Xworksheet(K{)
        copy  => '',  # Rs[worksheet(ȗ)
        after => '',  # ǉʒuafter[NV[g(ȗ)
        before=> ''   # ǉʒubefore[NV[g(ȗ)
    );
  # ɋLqꂽȍ~̖OtnbV擾AftHglփI[o[Cg
    my %args = (%defaults, @_);
    
  # bookIuWFNg擾
    my $book = get_book_obj($obj); return undef unless ($book);
  
  # worksheetXg擾
    my $sheet_list = getListWorksheets($obj);
  
  # x[Xworksheet͎wK{
    unless ($args{base} ne '') {
        $obj->error_msg("asrgument 'base' is mandatory in copyWorksheet method"); return undef;
    }
  
  # x[Xworksheet݂͑Ă
    my $base_found = 0;
    foreach my $base_name (@{$sheet_list}) {
        if ($args{base} eq $base_name) { $base_found = 1; last; }
    }
    unless ($base_found) { $obj->error_msg("worksheet '$args{base}' does not exist."); return undef; }
    
  # Rs[worksheet͊workseetƔȂ
    if ($args{copy} ne '') {
        foreach my $sheet_name (@{$sheet_list}) {
            if ($args{copy} eq $sheet_name) {
                $obj->error_msg("$args{copy} already exists in copyWorksheet method."); return undef;
            }
        }
    }
  
  # before/afterw莞afterD
    $args{after} = '' if (($args{after} ne '') and ($args{before} ne ''));
  
  # before/afterw̃[NV[g͑
    if (($args{after} ne '') or ($args{before} ne '')) {
        my $target_name = '';
        $target_name = $args{before} if ($args{before} ne '');
        $target_name = $args{after}  if ($args{after}  ne '');
        my $found = 0;
        foreach my $sheet_name (@{$sheet_list}) {
            if ($target_name eq $sheet_name) { $found = 1; last; }
        }
        unless ($found) { $obj->error_msg("$target_name does not exist."); return undef; }
    }
  # before/afterw薳ꍇAŏI[NV[gafterƂ
    else { $args{after} = $sheet_list->[$#{$sheet_list}]; }
    
  # x[Xworksheet̃IuWFNg擾
    my $sheet = get_sheet_obj($obj, $book, $args{base}); return undef unless($sheet);
  
  # x[XworksheetxlCellTypeLastCellAhX擾
  # ی삳ꂽV[głxlCellTypeLastCellAhX擾łȂUsedRangegp
    my $address_last_cell = $sheet->UsedRange()->Address();
    unless ($address_last_cell) {
        $obj->error_msg("failed to get last cell address from $args{base}.");
        return undef;
    }
    
  # A1UsedRange LastCell܂ł͈͕̔쐬(擪A1ɂ)
    my $all_addr = '';
    if ($address_last_cell =~ /^\s*(\S+):(\S+)\s*$/) { # UsedRange 2
        $all_addr = '$A$1:'.$2;
    }
    elsif ($address_last_cell =~ /^\s*(\S+)\s*$/) {    # UsedRange PZ
        $all_addr = '$A$1:'.$1;
    }
    else {
        $all_addr = '$A$1'; # ftHg
    }
    
  # w͈͂RangeIuWFNg擾
    my $range_all_base = get_range_obj($obj, $sheet, $all_addr);
    unless ($range_all_base) {
        $obj->error_msg("failed to get range objects from $args{base}.");
        return undef;
    }
    
  # [NV[gǉ
  # VBAIuWFNg̃\bh͖Ot(`:=\L)nbVQƌoRœn
    my $params;
    $params->{after}  = $book->Worksheets($args{after})  if ($args{after}  ne '');
    $params->{before} = $book->Worksheets($args{before}) if ($args{before} ne '');
    $params->{count} = 1;
    
  # ǉworksheetIuWFNg擾
    my $ret_sheet = $book->Worksheets->Add($params);
    unless(defined($ret_sheet)) { $obj->error_msg("add worksheet operation failed."); return undef; }
  
  # worksheet`FbNƐݒ
    $ret_sheet->{Name} = $args{copy} if (check_str_sheetname($obj, $args{copy}));
    
  # w͈͂copyRangeIuWFNg擾
    my $range_all_copy = get_range_obj($obj, $ret_sheet, $all_addr); return undef unless ($range_all_copy);
  
  # SrangẽRs[
    $range_all_base->Copy($range_all_copy);
  
  # gp͈͂1s1̊eZAhXXg擾
    my $list_addr = gen_range_address_list_top_left($obj, $sheet, $range_all_base);
    
  # SZWidthHeightRs[
    foreach my $cell_addr (@{$list_addr}) {
        my $height = $sheet->Range($cell_addr)->{EntireRow}->{RowHeight};
        my $width  = $sheet->Range($cell_addr)->{EntireColumn}->{ColumnWidth};
        #print "$cell_addr: $height, $width\n";
        $ret_sheet->Range($cell_addr)->{EntireRow}->{RowHeight} = $height;
        $ret_sheet->Range($cell_addr)->{EntireColumn}->{ColumnWidth} = $width;
    }
  
  # I
    $obj->msg("Worksheet '$ret_sheet->{Name}' is copied from $args{base}.");
    return($ret_sheet);
}

# ==============================================================================
# (Private)gp͈͂1s1eZAhXXg擾
# ߂l: undef(s) / Xgt@X()
# ==============================================================================
sub gen_range_address_list_top_left {
    my ($obj, $sheet, $range) = @_;
    my @ret;
    
    my $vals = $range->{Value}; # Range̎擾鐗`
    
    if ($obj->getTypeVal($vals) > 0) {
      # 2Ȃ烊t@X̃CfbNXcellvpeBŊeRange擾
      # ̌RangẽAhX߂
        for (my $r=0; $r<@{$vals}; $r++) {
            my $cell;
            my $adr;
          # 1sڂ͑S
            if ($r==0) {
                for (my $c=0; $c<@{$vals->[$r]}; $c++) {
                    $cell = $sheet->Cells($r+1, $c+1);
                    $adr = $cell->Address();
                    push(@ret, $adr);
                }
            }
          # 2sڈȍ~1ڂ̂
            else {
                $cell = $sheet->Cells($r+1, 1);
                $adr = $cell->Address();
                push(@ret, $adr);
            }
        }
    } else {
        push(@ret, $range->Address());
    }
    
    return \@ret;
}

# ==============================================================================
# w薼̃[NV[gCopy
# ߂l: undef(s) / Rs[ǉV[gIuWFNg()
# ==============================================================================
sub copyWorksheet {
  # 擪̃IuWFNgshiftŎ擾
    my $obj = shift(@_);
    
  # Ot`+ftHgݒ
    my %defaults = (
        base  => '',  # x[Xworksheet(K{)
        copy  => '',  # Rs[worksheet(ȗ)
        after => '',  # ǉʒuafter[NV[g(ȗ)
        before=> ''   # ǉʒubefore[NV[g(ȗ)
    );
  # ɋLqꂽȍ~̖OtnbV擾AftHglփI[o[Cg
    my %args = (%defaults, @_);
    
  # bookIuWFNg擾
    my $book = get_book_obj($obj); return undef unless ($book);
  
  # worksheetXg擾
    my $sheet_list = getListWorksheets($obj);
  
  # x[Xworksheet͎wK{
    unless ($args{base} ne '') {
        $obj->error_msg("argument 'base' is mandatory for copyWorksheet."); return undef;
    }
  
  # x[Xworksheet݂͑Ă
    my $base_found = 0;
    foreach my $base_name (@{$sheet_list}) {
        if ($args{base} eq $base_name) { $base_found = 1; last; }
    }
    unless ($base_found) { $obj->error_msg("worksheet '$args{base}' does not exist."); return undef; }
    
  # Rs[worksheet͊workseetƔȂ
    if ($args{copy} ne '') {
        foreach my $sheet_name (@{$sheet_list}) {
            if ($args{copy} eq $sheet_name) {
                $obj->error_msg("$args{copy} already exists at copyWorksheet."); return undef;
            }
        }
    }
  
  # before/afterw莞afterD
    $args{after} = '' if (($args{after} ne '') and ($args{before} ne ''));
  
  # before/afterw̃[NV[g͑
    if (($args{after} ne '') or ($args{before} ne '')) {
        my $target_name = '';
        $target_name = $args{before} if ($args{before} ne '');
        $target_name = $args{after}  if ($args{after}  ne '');
        my $found = 0;
        foreach my $sheet_name (@{$sheet_list}) {
            if ($target_name eq $sheet_name) { $found = 1; last; }
        }
        unless ($found) { $obj->error_msg("$target_name does not exist."); return undef; }
    }
  # before/afterw薳ꍇAŏI[NV[gafterƂ
    else { $args{after} = $sheet_list->[$#{$sheet_list}]; }
    
  # x[XworksheetIuWFNg擾
    my $sheet = get_sheet_obj($obj, $book, $args{base}); return undef unless($sheet);
  
  # VBAIuWFNg̃\bh͖Ot(`:=\L)nbVQƌoRœn
  # Win32::OLEoOWork AroundƎv
    my $params;
    $params->{after}  = $book->Worksheets($args{after})  if ($args{after}  ne '');
    $params->{before} = $book->Worksheets($args{before}) if ($args{before} ne '');
    
  # Rs[worksheet
    unless ($sheet->Copy($params)) { $obj->error_msg("copy worksheet operation failed."); return undef; }
  
  # Rs[worksheetIuWFNg擾
    my $application = $obj->{obj_excel};
    my $ret_sheet = $application->{ActiveSheet};
  
  # worksheet`FbNƐݒ
    $ret_sheet->{Name} = $args{copy} if (($args{copy} ne '') and check_str_sheetname($obj, $args{copy}));
  
  # I
    $obj->msg("Worksheet '$ret_sheet->{Name}' is copied from $args{base}.");
    return($ret_sheet);
}

# ==============================================================================
# w薼̃[NV[gǉ
# ߂l: undef(s) / ǉV[gIuWFNg()
# ==============================================================================
sub addWorksheet {
  # 擪̃IuWFNgshiftŎ擾
    my $obj = shift(@_);
    
  # Ot`+ftHgݒ
    my %defaults = (
        name  => '',  # ǉ[NV[g(ȗ)
        after => '',  # ǉʒuafter[NV[g(ȗ)
        before=> '',  # ǉʒubefore[NV[g(ȗ)
        count => 1    # ǉ[NV[g(ȗ)
    );
  # ɋLqꂽȍ~̖OtnbV擾AftHglփI[o[Cg
    my %args = (%defaults, @_);
    
  # bookIuWFNg擾
    my $book = get_book_obj($obj); return undef unless ($book);
  
  # worksheetXg擾
    my $sheet_list = getListWorksheets($obj);
    
  # ǉworksheet͊worksheetƔȂ
    if ($args{name} ne '') {
        foreach my $sheet_name (@{$sheet_list}) {
            if ($args{name} eq $sheet_name) {
                $obj->error_msg("$args{name} already exists in addWorksheet method."); return undef;
            }
        }
    }
  
  # before/afterw莞afterD
    $args{after} = '' if (($args{after} ne '') and ($args{before} ne ''));
  
  # before/afterw̃[NV[g͑
    if (($args{after} ne '') or ($args{before} ne '')) {
        my $target_name = '';
        $target_name = $args{before} if ($args{before} ne '');
        $target_name = $args{after}  if ($args{after}  ne '');
        my $found = 0;
        foreach my $sheet_name (@{$sheet_list}) {
            if ($target_name eq $sheet_name) { $found = 1; last; }
        }
        unless ($found) { $obj->error_msg("$target_name does not exist."); return undef; }
    }
  # before/afterw薳ꍇAŏI[NV[gafterƂ
    else { $args{after} = $sheet_list->[$#{$sheet_list}]; }
  
  # count͐l(ᔽ͋1)
    unless ($args{count} =~ /^\d+$/) {
        $obj->error_msg("$args{count} is not decimal for count argument so set force '1'.");
        $args{count} = 1;
    }
    
  # [NV[gǉ
  # VBAIuWFNg̃\bh͖Ot(`:=\L)nbVQƌoRœn
  # Win32::OLEoOWork AroundƎv
    my $params;
    $params->{after}  = $book->Worksheets($args{after})  if ($args{after}  ne '');
    $params->{before} = $book->Worksheets($args{before}) if ($args{before} ne '');
    $params->{count}  = $args{count};
    
  # ǉworksheetIuWFNg擾
    my $ret_sheet = $book->Worksheets->Add($params);
    unless(defined($ret_sheet)) { $obj->error_msg("add worksheet operation failed."); return undef; }
  
  # worksheet`FbNƐݒ
    $ret_sheet->{Name} = $args{name} if (check_str_sheetname($obj, $args{name}));
  
  # I
    $obj->msg("Worksheet '$ret_sheet->{Name}' is added.");
    return($ret_sheet);
}

# ==============================================================================
# (Private)worksheetɓKpł邱ƂmF
# ==============================================================================
sub check_str_sheetname {
    my ($obj, $name) = @_;
    my $ret = 1;
    
  # 2bytenɐK\Kp邽utf8fR[h
    my $name_dec = Encode::decode('cp932', $name);
    
    $ret = undef if ($name_dec =~ /^\s*$/);
    $ret = undef if (length($name_dec) > 31);
    $ret = undef if ($name_dec =~ /:|\\|\/|\?|\*|\[|\]/);
    
    $obj->error_msg("$name is illegal for worksheet name.") unless($ret);
    
    return $ret;
}

# ==============================================================================
# w背W/ZShapeu
# ߂l: undef(s) / ǉ摜ShapeIuWFNg()
# ==============================================================================
sub setShapeRange {
  # 擪̃IuWFNgshiftŎ擾
    my $obj = shift(@_);
    
  # Ot`+ftHgݒ
    my %defaults = (
        sheet  => '',       # worksheet
        range  => '',       # range
        shape  => 'circle', # Image File(ftHg~)
        offset => 1         # ZShapeʒuxyItZbgsNZ
    );
    
  # ɋLqꂽȍ~̖OtnbV擾AftHglփI[o[Cg
    my %args = (%defaults, @_);
    
  # bookIuWFNg擾
    my $book = get_book_obj($obj); return undef unless ($book);
    
  # w背WOtWmFBOtWȂsheetw薳
    my $range_is_named = get_type_range($obj, $args{range}, $args{sheet});
  
  # range,sheetIuWFNg擾(OtW͐擪݈̂߁Aget/setValRangeƔɈقȂ)
    my $range;
    my $sheet;
    # OtW
      if ($range_is_named) {
        # OtW̃Z\擾
          my $cell_list = get_cell_list_of_named_range($obj, $book, $args{range}); return undef unless ($cell_list);
          $sheet = get_sheet_obj($obj, $book,  $cell_list->[0]->{sheet}); return undef unless ($sheet);
          $range = get_range_obj($obj, $sheet, $cell_list->[0]->{range}); return undef unless ($range);
      }
    # ʏ탌W
      else {
          $sheet = get_sheet_obj($obj, $book,  $args{sheet}); return undef unless ($sheet);
          $range = get_range_obj($obj, $sheet, $args{range}); return undef unless ($range);
      }
  
  # AddShapeւ̈ݒ
    my $args_shape = set_args_for_addshape($range, \%args);
  
  # Sheet ShapesRNVւAddPictures
    my $shape = $sheet->{Shapes}->AddShape(
        $args_shape->{Shape},
        $args_shape->{Left},
        $args_shape->{Top},
        $args_shape->{Width},
        $args_shape->{Height},
    );
    
    unless($shape) {
        $obj->error_msg("Shape '$args{shape}' can not be added to '$args{range}'.");
        return undef;
    }
  
  # ftHgwiF:hԂ
    $shape->{Fill}->{Visible} = $_G_msoFalse;
  # ftHg:/1|Cg
    $shape->{Line}->{ForeColor}->{RGB} = get_pseudo_vba_rgb(0,0,0); # 
    $shape->{Line}->{Weight} = 1; # 1|Cg
    
  # I
    $obj->msg("Shape '$args{shape}' is put on '$args{range}'.");
    return $shape;
}


# ==============================================================================
# (Private)^Excel VBA RGB֐
# ==============================================================================
sub get_pseudo_vba_rgb {
    my ($red, $green, $blue) = @_;
    
    my $rgb = ($blue*256*256) + ($green*256) + ($red);
    
    return $rgb;
}

# ==============================================================================
# (Private)AddShape\bhւ̈ݒ
# https://learn.microsoft.com/ja-jp/office/vba/api/excel.shapes.addshape
# ==============================================================================
sub set_args_for_addshape {
    my ($range, $args) = @_;
    
  # ߂lnbVt@X
    my $args_shape;
  
  # shapeݒ
    $args_shape->{Shape} = $_G_msoShapeOval;
    $args_shape->{Shape} = $_G_msoShapeOval      if ($args->{shape} =~ /circle/i);    # ~
    $args_shape->{Shape} = $_G_msoShapeRectangle if ($args->{shape} =~ /rectangle/i); # `
    $args_shape->{Shape} = $_G_msoShapeOval      if ($args->{shape} =~ /oval/i);      # ȉ~
  
  # w背Wʒu/TCY擾(ŃItZbgl)
    my $cell_top    = $range->{Top}    + $args->{offset};
    my $cell_left   = $range->{Left}   + $args->{offset};
    my $cell_width  = $range->{Width}  - ($args->{offset}*2);
    my $cell_height = $range->{Height} - ($args->{offset}*2);
  
  # Shape~̏ꍇZ^O߂
    if ($args->{shape} =~ /circle/i) {
      # Z͉
        if ($cell_width > $cell_height) {
            $args_shape->{Top}    = $cell_top;
            $args_shape->{Left}   = $cell_left + (($cell_width-$cell_height)/2);
            $args_shape->{Width}  = $cell_height;
            $args_shape->{Height} = $cell_height;
        }
      # Z͏c
        else {
            $args_shape->{Top}    = $cell_top + (($cell_height-$cell_width)/2);
            $args_shape->{Left}   = $cell_left;
            $args_shape->{Width}  = $cell_width;
            $args_shape->{Height} = $cell_width;
        }
    }
  # Shapeȉ~/`ȂZ̑傫ɍ킹
    else {
        $args_shape->{Top}    = $cell_top;
        $args_shape->{Left}   = $cell_left;
        $args_shape->{Width}  = $cell_width;
        $args_shape->{Height} = $cell_height;
    }
    
  # ݒl߂
    return $args_shape;
}


# ==============================================================================
# w背W/ZImageu
# ߂l: undef(s) / ǉ摜ShapeIuWFNg ()
# ==============================================================================
sub setImgRange {
  # 擪̃IuWFNgshiftŎ擾
    my $obj = shift(@_);
    
  # Ot`+ftHgݒ
    my %defaults = (
        sheet  => '',    # worksheet
        range  => '',    # range
        img    => undef, # Image File
        adjust => 1,     # 摜TCY   0:TCYŃZɒu,     1:W̃ZTCYɍ킹(default)
        aspect => 1,     # Image Aspect 0:ێ,                     1:ێ(default)
        center => 1,     # Z^O 0:摜Z̍ɍ킹, 1:摜ZɃZ^O(default)
        link   => 0,     # Image Link   0:t@CփRs[(default),  1:N
        offset => 1      # Z摜ʒuxyItZbgsNZ
    );
    
  # ɋLqꂽȍ~̖OtnbV擾AftHglփI[o[Cg
    my %args = (%defaults, @_);
    
  # imgt@C͗^Ă?
    unless (defined($args{img})) {
        $obj->error_msg("Argument 'img' is mandatory.");
        return undef;
    }
    
  # imgt@C͂?
    unless (-f $args{img}) {
        $obj->error_msg("Image file '$args{img}' is not found.");
        return undef;
    }
  
  # ExcelփRs[/Nې΃pXKvȂ̂ŁAFSOGetAbsolutePathNameŕϊ
    my $objFso = Win32::OLE->new('Scripting.FileSystemObject');
    my $img_fullpath = $objFso->GetAbsolutePathName($args{img});
    $objFso = undef; # FSO
    
  # bookIuWFNg擾
    my $book = get_book_obj($obj); return undef unless ($book);
    
  # w背WOtWmFBOtWȂsheetw薳
    my $range_is_named = get_type_range($obj, $args{range}, $args{sheet});
  
  # range,sheetIuWFNg擾(OtW͐擪݈̂߁Aget/setValRangeƔɈقȂ)
    my $range;
    my $sheet;
    # OtW
      if ($range_is_named) {
        # OtW̃Z\擾
          my $cell_list = get_cell_list_of_named_range($obj, $book, $args{range}); return undef unless ($cell_list);
          $sheet = get_sheet_obj($obj, $book,  $cell_list->[0]->{sheet}); return undef unless ($sheet);
          $range = get_range_obj($obj, $sheet, $cell_list->[0]->{range}); return undef unless ($range);
      }
    # ʏ탌W
      else {
          $sheet = get_sheet_obj($obj, $book,  $args{sheet}); return undef unless ($sheet);
          $range = get_range_obj($obj, $sheet, $args{range}); return undef unless ($range);
      }
  
  # AddPictureւ̈ݒ
    my $args_pict = set_args_for_addpicture($img_fullpath, $range, \%args);
  
  # Sheet ShapesRNVւAddPictures
    my $shape = $sheet->{Shapes}->AddPicture(
        $args_pict->{FileName},
        $args_pict->{LinkToFile},
        $args_pict->{SaveWithDocument},
        $args_pict->{Left},
        $args_pict->{Top},
        $args_pict->{Width},
        $args_pict->{Height},
    );
    
    unless($shape) {
        $obj->error_msg("Image file '$args{img}' can not be added to '$args{range}'.");
        return undef;
    }
  
  # I
    $obj->msg("Image file '$args{img}' is put on '$args{range}'.");
    return $shape;
}

# ==============================================================================
# (Private)AddPicture\bhւ̈ݒ
# https://docs.microsoft.com/ja-jp/office/vba/api/excel.shapes.addpicture
# ==============================================================================
sub set_args_for_addpicture {
    my ($img, $range, $args) = @_;
    
  # ߂lnbVt@X
    my $args_pict;
  
  # imgt@Cݒ
    $args_pict->{FileName} = $img;
    
  # linkݒ
    if ($args->{link} == 1) {
        $args_pict->{LinkToFile} = $_G_msoTrue;
        $args_pict->{SaveWithDocument} = $_G_msoFalse;
    } else {
        $args_pict->{LinkToFile} = $_G_msoFalse;
        $args_pict->{SaveWithDocument} = $_G_msoTrue;
    }
    
  # imgt@Cwidth/hightTCY擾
    my ($img_width, $img_height) = imgsize($img); # imgsize  Image::Size ̊֐
  
  # w背Wʒu/TCY擾(ŃItZbgl)
    my $cell_top    = $range->{Top}    + $args->{offset};
    my $cell_left   = $range->{Left}   + $args->{offset};
    my $cell_width  = $range->{Width}  - ($args->{offset}*2);
    my $cell_height = $range->{Height} - ($args->{offset}*2);
    
  # adjust:C[WTCYW̃ZTCYɍ킹
    if ($args->{adjust} > 0) {
      # aspect:AXyNgێ
        if ($args->{aspect} > 0) {
          # ύX䗦
            my $mod_ratio = 1;
          # ܂킹(䗦߂)ItZbgZTCYɐݒ
            my $r_width  = $cell_width / $img_width;
          # ύX̍䗦
            my $r_height = $cell_height / ($img_height * $r_width);
          # Z͂ݏoȂ($r_height >= 1)̂܂
            if ($r_height >= 1) {
                $mod_ratio = $r_width * 1;
            }
          # Z͂ݏoΏk߂
            else {
                $mod_ratio = $r_width * $r_height;
            }
          # width/ratioݒ
            $args_pict->{Width}  = $img_width  * $mod_ratio;
            $args_pict->{Height} = $img_height * $mod_ratio;
        }
      # aspect:AXyNgێȂ
        else {
            $args_pict->{Width}  = $cell_width;
            $args_pict->{Height} = $cell_height;
        }
    }
  # adjust:C[WTCYW̃ZTCYɍ킹Ȃ(TCYŒu)
    else {
        $args_pict->{Width}  = $img_width;
        $args_pict->{Height} = $img_height;
    }
    
  # center:Z^O(ZTCY傫-ItZbg/+ItZbg)
    if ($args->{center} > 0) {
        $args_pict->{Left} = $cell_left + (($cell_width  - $args_pict->{Width})  / 2);
        $args_pict->{Top}  = $cell_top  + (($cell_height - $args_pict->{Height}) / 2);
      
      # W0ȉɂȂꍇ0ɏC
        $args_pict->{Left} = 0 if ($args_pict->{Left} < 0);
        $args_pict->{Top}  = 0 if ($args_pict->{Top}  < 0);
    }
  # center:Z^OȂ
    else {
        $args_pict->{Left} = $cell_left;
        $args_pict->{Top}  = $cell_top;
    }
  
  # ݒl߂
    return $args_pict;
}

# ==============================================================================
# (Private)w背WOtWʏ탌W𔻒f
# ߂l: undef(ʏ탌W) / 1(OtW)
# ==============================================================================
sub get_type_range {
    my ($obj, $name_range, $name_sheet) = @_;
  
  # ߂lݒ(undef)
    my $ret = undef;
    
  # OtW̃Xg擾
    my $list_named_ranges = getListNamedRanges($obj);
  
  # w背WOtWXgɑ݂邩
    if ($list_named_ranges) {
        if (grep {$_ eq $name_range} @{$list_named_ranges}) {
          # ʂTrueȂΖ߂l1(True)ݒ肵ASheetւ̃bZ[W\
            $ret = 1;
            $obj->msg("'$name_range' is named range.");
            $obj->msg("'$name_range' is named range so '$name_sheet' is ignored.") if ($name_sheet ne '')
        }
    }
    
    $obj->msg("'$name_range' is normal range.") unless ($ret);
    
    return $ret;
}

# ==============================================================================
# wV[gUsedRangeɒlݒ肷
# ߂l: undef(s) / 1 ()
# ==============================================================================
sub setValUsedRange {
  # 擪̃IuWFNgshiftŎ擾
    my $obj = shift(@_);
    
  # Ot`
    my %defaults = (
        sheet => '',   # worksheet
        value => undef # ݒl
    );
    
  # ɋLqꂽȍ~̖OtnbV擾AftHglփI[o[Cg
    my %args = (%defaults, @_);
    
  # bookIuWFNg擾
    my $book = get_book_obj($obj); return undef unless ($book);
    
  # value͗^Ă?
    unless (defined($args{value})) {
        $obj->error_msg("Argument 'value' is mandatory.");
        return undef;
    }
  
  # valuetype2Xgt@XXJ[?
    my $type_of_value = getTypeVal($obj, $args{value});
    return undef unless (check_no_undef_or_1dim($obj, $type_of_value));
    
  # sheet,rangeIuWFNg擾
    my $sheet = get_sheet_obj($obj, $book,  $args{sheet}); return undef unless ($sheet);
  
  # UsedRangef[^擾(f[^̏ꍇundef߂)
    my $cur_value = $sheet->{UsedRange}->{Value};
    
  # f[^Ɛݒf[^rWrite̓샂[h߂
    my $act_mode = get_type_of_compare($obj, $cur_value, $args{value}); return undef unless ($act_mode);
    $obj->msg("Compare result is '$act_mode'.");
    
  # CurrentRegion/UsedRange1Xg͈Ȃ
    if (
        ($act_mode == $_G_Sc_Cs_M1) or # scalar/1-dim
        ($act_mode == $_G_Sc_C1_Ms) or # 1-dim /scalar
        ($act_mode == $_G_Sc_C1_M1) or # 1-dim /1-dim
        ($act_mode == $_G_Sc_Cu_M1)    # undef /1-dim
    ) {
        return undef;
    }
    
  # UsedRangeɒlݒ
    return undef unless (set_val_to_used_range($obj, $sheet, $act_mode, $cur_value, $args{value}));
    
  # I
    return 1;
}

# ==============================================================================
# (Private)w蓮샂[hɏ]UsedRangeɒlݒ肷
# 샂[hɂĂ get_type_of_compare ̐Q
# ==============================================================================
sub set_val_to_used_range {
    my ($obj, $sheet, $act_mode, $cur, $mod) = @_;
    
    return undef unless(defined($act_mode)); # 샂[hundef`FbN
    return undef unless(defined($mod)); # ύXlundef`FbN
    
  # sl(erase, 2-dim)
    if (($act_mode == $_G_Sc_C2_Ms) or ($act_mode == $_G_Sc_C2_M2)) {
        for (my $r=0; $r<@{$cur}; $r++) {
            for (my $c=0; $c<@{$cur->[$r]}; $c++) {
                $cur->[$r]->[$c] = '';
            }
        }
      # l
        $sheet->{UsedRange}->{Value} = $cur;
    }
    
  # ͈͕ύX and (resize, scalar & 2-dim)
    if ($act_mode > $_G_Sc_Cs_Ms) { # scalarmȊOresize{
        if ($act_mode == $_G_Sc_C2_Ms) { # 2-dim --> scalar
            $sheet->{UsedRange}->Resize(1,1);
        }
        elsif (($act_mode == $_G_Sc_Cs_M2) or ($act_mode == $_G_Sc_C2_M2)) { # scalar/2-dim --> 2-dim
            $sheet->{UsedRange}->Resize($#{$mod}+1, $#{$mod->[0]}+1)->{Value} = $mod;
        }
    } elsif ($act_mode == $_G_Sc_Cs_Ms) { # scalar --> scalar
        $sheet->{UsedRange}->{Value} = $mod;
    }
    
  # I
    return 1;
}

# ==============================================================================
# wSheetUsedRegion̒l擾
# ߂l: undef(s) / 2Xgt@X()
# ==============================================================================
sub getValUsedRange {
    my ($obj, $name_sheet) = @_;
    
  # bookIuWFNg擾
    my $book = get_book_obj($obj); return undef unless ($book);
    
  # sheetIuWFNg擾
    my $sheet = get_sheet_obj($obj, $book, $name_sheet); return undef unless ($sheet);
    
  # UsedRange rangeIuWFNg擾
    my $used_range = $sheet->UsedRange();
    unless ($used_range) {
        $obj->error_msg("UsedRange for '$name_sheet' can not be got.");
        return undef;
    }
    $obj->msg("UsedRange for '$name_sheet' is found.");
  
  # UsedRangel擾
    my $value = $used_range->{Value};
  
  # ǂݎl߂
    return $value;
}

# ==============================================================================
# w背WCurrentRegionɒlݒ肷
# ߂l: undef(s) / 1 ()
# ==============================================================================
sub setValCurrentRegion {
  # 擪̃IuWFNgshiftŎ擾
    my $obj = shift(@_);
    
  # Ot`
    my %defaults = (
        sheet => '',   # worksheet
        range => '',   # range
        value => undef # ݒl
    );
    
  # ɋLqꂽȍ~̖OtnbV擾AftHglփI[o[Cg
    my %args = (%defaults, @_);
    
  # bookIuWFNg擾
    my $book = get_book_obj($obj); return undef unless ($book);
    
  # value͗^Ă?
    unless ($args{value}) {
        $obj->error_msg("Argument 'value' is mandatory.");
        return undef;
    }
  
  # valuetype2Xgt@XXJ[?
    my $type_of_value = getTypeVal($obj, $args{value});
    return undef unless (check_no_undef_or_1dim($obj, $type_of_value));
    
  # w背WOtWmFBOtWȂsheetw薳
    my $range_is_named = get_type_range($obj, $args{range}, $args{sheet});
    
  # OtWȂsheetw𖳎
    if ($range_is_named){
        $args{sheet} = get_name_sheet_of_named_range($obj, $book, $args{range});
        return undef unless ($args{sheet});
    }
    
  # sheet,rangeIuWFNg擾
    my $sheet = get_sheet_obj($obj, $book,  $args{sheet}); return undef unless ($sheet);
    my $range = get_range_obj($obj, $sheet, $args{range}); return undef unless ($range);
  
  # CurrentRegionf[^擾(f[^̏ꍇundef߂)
    my $cur_value = $range->{CurrentRegion}->{Value};
    
  # f[^Ɛݒf[^rWrite̓샂[h߂
    my $act_mode = get_type_of_compare($obj, $cur_value, $args{value}); return undef unless (defined($act_mode));
    $obj->msg("Compare result is '$act_mode'.");
    
  # CurrentRegion/UsedRange1Xg͈Ȃ
    if (
        ($act_mode == $_G_Sc_Cs_M1) or # scalar/1-dim
        ($act_mode == $_G_Sc_C1_Ms) or # 1-dim /scalar
        ($act_mode == $_G_Sc_C1_M1) or # 1-dim /1-dim
        ($act_mode == $_G_Sc_Cu_M1)    # undef /1-dim
    ) {
        return undef;
    }
  # CuurentRegionɒlݒ
    return undef unless (set_val_to_current_region($obj, $range, $act_mode, $cur_value, $args{value}));
    
  # I
    return 1;
}

# ==============================================================================
# (Private)w蓮샂[hɏ]CurrentRegionɒlݒ肷
# 샂[hɂĂ get_type_of_compare ̐Q
# ==============================================================================
sub set_val_to_current_region {
    my ($obj, $range, $act_mode, $cur, $mod) = @_;
    
    return undef unless(defined($act_mode)); # 샂[hundef`FbN
    return undef unless(defined($mod));      # ύXlundef`FbN
    
  # sl(erase, 2-dim)
    if (($act_mode == $_G_Sc_C2_Ms) or ($act_mode == $_G_Sc_C2_M2)) {
        for (my $r=0; $r<@{$cur}; $r++) {
            for (my $c=0; $c<@{$cur->[$r]}; $c++) {
                $cur->[$r]->[$c] = '';
            }
        }
      # l
        $range->{CurrentRegion}->{Value} = $cur;
    }
    
  # ͈͕ύX and (resize, scalar & 2-dim)
    if ($act_mode > 0) { # scalarmȊOresize{
        if ($act_mode == $_G_Sc_C2_Ms) { # 2-dim --> scalar
            $range->{CurrentRegion}->Resize(1,1);
        }
        elsif (($act_mode == $_G_Sc_Cs_M2) or ($act_mode == $_G_Sc_C2_M2)) { # scalar/2-dim --> 2-dim
            $range->{CurrentRegion}->Resize($#{$mod}+1, $#{$mod->[0]}+1)->{Value} = $mod;
        }
    } elsif ($act_mode == $_G_Sc_Cs_Ms) { # scalar --> scalar
        $range->{CurrentRegion}->{Value} = $mod;
    }
    
  # I
    return 1;
}

# ==============================================================================
# (Private)f[^Ɛݒf[^̔rs茋ʂ߂
# 2Xg̓AXyNgႢ̂ŁAerase/write{ƂTCYʖ
# +=============+=========+=========+========+====================+=======+
# |return       |cur      |mod      |size    |expected_action     |comment|
# +=============+=========+=========+========+====================+=======+
# |undef        |scalar   |undef    |-       |-    , -     , -    |-      |
# |$_G_Sc_Cs_Ms |scalar   |scalar   |cur==mod|-    , -       write|-      |
# |$_G_Sc_Cs_M1 |scalar   |1-dim_ref|cur<=mod|-    , resize, write|named  |
# |$_G_Sc_Cs_M2 |scalar   |2-dim_ref|cur<=mod|-    , resize, write|-      |
# +-------------+---------+---------+--------+--------------------+-------+
# |undef        |1-dim_ref|undef    |-       |-    , -     , -    |-      |
# |$_G_Sc_C1_Ms |1-dim_ref|scalar   |cur>=mod|erase, resize, write|-      |
# |$_G_Sc_C1_M1 |1-dim_ref|1_dim_ref|-       |erase, resize, write|named  |
# |undef        |1-dim_ref|2_dim_ref|-       |-    , -     , -    |-      |
# +-------------+---------+---------+--------+--------------------+-------+
# |undef        |2-dim_ref|undef    |-       |-    , -     , -    |-      |
# |$_G_Sc_C2_Ms |2-dim_ref|scalar   |cur>=mod|erase, resize, write|-      |
# |undef        |2-dim_ref|1-dim_ref|-       |-    , -     , -    |named  |
# |$_G_Sc_C2_M2 |2-dim_ref|2_dim_ref|-       |erase, resize, write|aspect |
# +-------------+---------+---------+--------+--------------------+-------+
# |undef        |undef    |undef    |-       |-    , -     , -    |-      |
# |$_G_Sc_Cu_Ms |undef    |scalar   |cur< mod|-    , resize, write|-      |
# |$_G_Sc_Cu_M1 |undef    |1-dim_ref|cur< mod|-    , resize, write|named  |
# |$_G_Sc_Cu_M2 |undef    |2-dim_ref|cur< mod|-    , resize, write|-      |
# +=============+=========+=========+========+====================+=======+
sub get_type_of_compare {
    my ($obj, $cur, $mod) = @_;
    
  # $modundefȂundef߂
    return undef unless (defined($mod));
    
  # $cur$modType擾(\bhėp)
    my $type_cur = $obj->getTypeVal($cur);
    my $type_mod = $obj->getTypeVal($mod);
  
  # f[^undefꍇ
    unless (defined($type_cur)) {
        return undef unless (defined($type_mod));  # undef/undef
        return $_G_Sc_Cu_Ms if ($type_mod == 0); # undef/scalar
        return $_G_Sc_Cu_M1 if ($type_mod == 1); # undef/1-dim
        return $_G_Sc_Cu_M2 if ($type_mod == 2); # undef/2-dim
        return undef;                            # P[XȂꍇundef߂
    }
  # f[^XJ[̏ꍇ
    if ($type_cur == 0) {
        return undef unless (defined($type_mod));  # scalar/undef
        return $_G_Sc_Cs_Ms if ($type_mod == 0); # scalar/scalar
        return $_G_Sc_Cs_M1 if ($type_mod == 1); # scalar/1-dim
        return $_G_Sc_Cs_M2 if ($type_mod == 2); # scalar/2-dim
    }
  # f[^1Xgt@X̏ꍇ
    elsif ($type_cur == 1) {
        return undef unless (defined($type_mod));  # 1-dim/undef
        return $_G_Sc_C1_Ms if ($type_mod == 0); # 1-dim/scalar
        return $_G_Sc_C1_M1 if ($type_mod == 1); # 1-dim/1-dim
        return undef        if ($type_mod == 2); # 1-dim/2-dim
    }
  # f[^1Xgt@X̏ꍇ
    elsif ($type_cur == 2) {
        return undef unless (defined($type_mod));  # 2-dim/undef
        return $_G_Sc_C2_Ms if ($type_mod == 0); # 2-dim/scalar
        return undef        if ($type_mod == 1); # 2-dim/1-dim
        return $_G_Sc_C2_M2 if ($type_mod == 2); # 2-dim/2-dim
    }
    
  # P[XɂȂꍇundef߂
    return undef;
}

# ==============================================================================
# (Private)undef܂1dimXgł͂ȂƂmF
# ߂l
#   1:OK, undef:undef1dim
# ==============================================================================
sub check_no_undef_or_1dim {
    my ($obj, $type_of_value) = @_;
    
  # undefo
    unless (defined($type_of_value)) {
        $obj->error_msg("Argument 'value' is undefined.");
        return undef;
    }
  
  # 1Xgo
    if ($type_of_value == 1) {
        $obj->error_msg("Argument 'value' of setValCurrentRegion needs 2-dim list reference or scalar.");
        return undef;
    }
    
  # I
    return 1;
}

# ==============================================================================
# ̃f[^^Cv߂
# ߂l:
#   0:XJ[, 1:1Xgt@X, 2:2Xgt@X, undef:undef
# ==============================================================================
sub getTypeVal {
    my ($obj, $value) = @_;
    
    if (ref($value) eq 'ARRAY') {
        if (ref($value->[0]) eq 'ARRAY') {
            return 2; # 2Xgt@X
        } else {
            return 1; # 1Xgt@X
        }
    }
    
    return undef unless (defined($value));
    
    return 0; # XJ[
}

# ==============================================================================
# w背WCurrentRegion̒l擾
# ߂l: undef(s) / 2Xgt@X()
# ==============================================================================
sub getValCurrentRegion {
  # 擪̃IuWFNgshiftŎ擾
    my $obj = shift(@_);
    
  # Ot`
    my %defaults = (
        sheet => '', # worksheet
        range => ''  # range
    );
    
  # ɋLqꂽȍ~̖OtnbV擾AftHglփI[o[Cg
    my %args = (%defaults, @_);
    
  # bookIuWFNg擾
    my $book = get_book_obj($obj); return undef unless ($book);
    
  # w背WOtWmFBOtWȂsheetw薳
    my $range_is_named = get_type_range($obj, $args{range}, $args{sheet});
    
  # OtWȂsheet𖳎ď擾
    if ($range_is_named){
        $args{sheet} = get_name_sheet_of_named_range($obj, $book, $args{range});
        return undef unless ($args{sheet});
    }
    
  # sheetIuWFNg擾
    my $sheet = get_sheet_obj($obj, $book, $args{sheet}); return undef unless ($sheet);
    
  # rangeIuWFNg擾
    my $range = get_range_obj($obj, $sheet, $args{range}); return undef unless ($range);
  
  # CurrentRegion擾
    my $value = $range->{CurrentRegion}->{Value};
    
  # ǂݎl߂
    return $value
}

# ==============================================================================
# w胏[NV[g̑SĂ̒l擾
# ߂l: undef(s) / 2Xgt@X()
# ==============================================================================
sub getValWorksheet {
    my ($obj, $name_sheet) = @_;
    
  # bookIuWFNg擾
    my $book = get_book_obj($obj); return undef unless ($book);
    
  # sheetIuWFNg擾
    my $sheet = get_sheet_obj($obj, $book, $name_sheet); return undef unless ($sheet);
    
  # x[XworksheetxlCellTypeLastCellAhX擾
  # ی삳ꂽV[głxlCellTypeLastCellAhX擾łȂUsedRangegp
    my $address_last_cell = $sheet->UsedRange()->Address();
    unless ($address_last_cell) {
        $obj->error_msg("failed to get last cell address from $name_sheet.");
        return undef;
    }
    
  # A1UsedRange LastCell܂ł͈͕̔쐬(擪A1ɂ)
    my $all_addr = '';
    if ($address_last_cell =~ /^\s*(\S+):(\S+)\s*$/) { # UsedRange 2
        $all_addr = '$A$1:'.$2;
    }
    elsif ($address_last_cell =~ /^\s*(\S+)\s*$/) {    # UsedRange PZ
        $all_addr = '$A$1:'.$1;
    }
    else {
        $all_addr = '$A$1'; # ftHg
    }
    
  # w͈͂RangeIuWFNg擾
    my $range = get_range_obj($obj, $sheet, $all_addr); return undef unless ($range);
    
  # Range̒l擾
    my $value = $range->{Value};
    
  # ǂݎl߂
    return $value;
}

# ==============================================================================
# openĂExcel̖OtRangeXg擾
# ߂l: undef(s)/Xgt@X()
# ==============================================================================
sub getListNamedRanges {
    my ($obj) = @_;
    
  # bookIuWFNg擾
    my $book = get_book_obj($obj); return undef unless ($book);
    
  # OtRangeCollection擾
    my $collection_named_ranges = $book->Names();
  
  # OtRangeWin32::OLE::EnumIuWFNg擾
    my $enum_named_ranges = Win32::OLE::Enum->new($collection_named_ranges);
    
  # OtRangẽXg쐬
    my @named_ranges = $enum_named_ranges->All();
    my @ret;
    
    for (my $i=0; $i<@named_ranges; $i++) {
        push(@ret, $named_ranges[$i]->Name());
    }
  
  # EnumIuWFNg(Ô)
    $enum_named_ranges = undef;
    
  # Xg̃t@X߂
    return \@ret;
}

# ==============================================================================
# openĂExcel̃[NV[gXg擾
# ߂l: undef(s)/Xgt@X()
# ==============================================================================
sub getListWorksheets {
    my ($obj) = @_;
    
  # bookIuWFNg擾
    my $book = get_book_obj($obj); return undef unless ($book);
    
  # WorksheetXg擾
    my @ret;
    
    for (my $i=1; $i <= $book->Sheets()->Count(); $i++) {
        push(@ret, $book->Worksheets($i)->Name());
        $obj->msg("Worksheet '$ret[$#ret]' is found.");
    }
  
  # Xg̃t@X߂
    return \@ret;
}

# ==============================================================================
# w背WɒlݒBsheetȗ͖OtWƂĐݒ菈B
# ߂l: undef(s)/1()
# ==============================================================================
sub setValRange {
  # 擪̃IuWFNgshiftŎ擾
    my $obj = shift(@_);
    
  # Ot`
    my %defaults = (
        sheet => '',   # worksheet
        range => '',   # range
        value => undef # ݒl
    );
    
  # ɋLqꂽȍ~̖OtnbV擾AftHglփI[o[Cg
    my %args = (%defaults, @_);
  
  # bookIuWFNg擾
    my $book = get_book_obj($obj); return undef unless ($book);
    
  # w背WOtWmFBOtWȂsheetw薳
    my $range_is_named = get_type_range($obj, $args{range}, $args{sheet});
  
  # value͗^Ă?
    unless (defined($args{value})) {
        $obj->error_msg("Argument 'value' is mandatory.");
        return undef;
    }
    
  # valuetypeʁBXJ[͐BARRAY͒ʏ탌W/OtWŔʁB
    my $value_type = getTypeVal($obj, $args{value}); # 0:scalar, 1:1list_ref, 2:2list_ref
    
    if ($value_type == 1) { # 1Xg
        unless($range_is_named) {
            $obj->error_msg("Range is normal but the value is 1-dimension list reference.");
            return undef;
        }
    }
    
  # OtWɒlݒ
    if ($range_is_named) {
      # OtW̃Z\擾
        my $cell_list = get_cell_list_of_named_range($obj, $book, $args{range}); return undef unless ($cell_list);
      # lݒ: Z
        if ($#{$cell_list} > 0) {
            for (my $i=0; $i<=$#{$cell_list}; $i++) {
                my $sheet = get_sheet_obj($obj, $book,  $cell_list->[$i]->{sheet}); return undef unless ($sheet);
                my $range = get_range_obj($obj, $sheet, $cell_list->[$i]->{range}); return undef unless ($range);
              # Wی삳ĂꍇbZ[Wo
                if ($sheet->{ProtectContents} and $range->{Locked}) {
                    $obj->error_msg("$cell_list->[$i]->{sheet}!$cell_list->[$i]->{range} is locked.");
                }
                $range->{Value} = $args{value}->[$i] if (defined($args{value}->[$i]));
            }
        }
      # lݒ: PZ
        else {
            my $sheet = get_sheet_obj($obj, $book,  $cell_list->[0]->{sheet}); return undef unless ($sheet);
            my $range = get_range_obj($obj, $sheet, $cell_list->[0]->{range}); return undef unless ($range);
          # Wی삳ĂꍇbZ[Wo
            if ($sheet->{ProtectContents} and $range->{Locked}) {
                $obj->error_msg("$cell_list->[0]->{sheet}!$cell_list->[0]->{range} is locked.");
            }
            $range->{Value} = $args{value}; # XJ[
        }
    }
  # ʏ탌Wɒlݒ
    else {
        my $sheet = get_sheet_obj($obj, $book,  $args{sheet}); return undef unless ($sheet);
        my $range = get_range_obj($obj, $sheet, $args{range}); return undef unless ($range);
        $range->{Value} = $args{value}; # ValueݒValueoϐɒړ
    }
    
  # I
    return 1;
}

# ==============================================================================
# w背W̒l擾Bsheetȗ͖OtWƂĎ擾B
# PZ: XJ[l߂B
# Z:
#   ʏ탌W    : 2Xgt@X߂B$ret->[s]->[]B
#   OtW: 1Xgt@X߂B$ret->[CfbNX]
#                 : 1Xgvf̓XJ[/1/2QƂ̉
# ==============================================================================
sub getValRange {
  # 擪̃IuWFNgshiftŎ擾
    my $obj = shift(@_);
    
  # Ot`
    my %defaults = (
        sheet => '', # worksheet
        range => ''  # range
    );
    
  # ɋLqꂽȍ~̖OtnbV擾AftHglփI[o[Cg
    my %args = (%defaults, @_);
  
  # bookIuWFNg擾
    my $book = get_book_obj($obj); return undef unless ($book);
    
  # w背WOtWmFBOtWȂsheetw薳
    my $range_is_named = get_type_range($obj, $args{range}, $args{sheet});
    
  # Sheet/Range̒l擾
    my $value;
  
  # OtW
    if ($range_is_named) {
      # OtW̃Z\擾
        my $cell_list = get_cell_list_of_named_range($obj, $book, $args{range}); return undef unless ($cell_list);
      # 擾: Z
        if ($#{$cell_list} > 0) {
            for (my $i=0; $i<=$#{$cell_list}; $i++) {
                my $sheet = get_sheet_obj($obj, $book,  $cell_list->[$i]->{sheet}); return undef unless ($sheet);
                my $range = get_range_obj($obj, $sheet, $cell_list->[$i]->{range}); return undef unless ($range);
                push(@{$value}, $range->{Value});
                # OtW̖߂l͔ɖʓ|
                # L1Xg̗vfɃXJ[/1t@X/2t@X
                # \bhpŊevf̃f[^^𔻕ʂđΉKv
            }
        }
      # 擾: PZ
        else {
            my $sheet = get_sheet_obj($obj, $book,  $cell_list->[0]->{sheet}); return undef unless ($sheet);
            my $range = get_range_obj($obj, $sheet, $cell_list->[0]->{range}); return undef unless ($range);
            $value = $range->{Value}; # PZ̓XJ[Ŗ߂
        }
    }
  # ʏ탌W
    else {
        my $sheet = get_sheet_obj($obj, $book,  $args{sheet}); return undef unless ($sheet);
        my $range = get_range_obj($obj, $sheet, $args{range}); return undef unless ($range);
        $value = $range->{Value}; # ߂lXJ[/2Xgt@X̓\bh߂
    }
    
  # ǂݎl߂
    return $value;
}


# ==============================================================================
# Excelt@Ccopy
# ߂l: undef(s)/1()
# ==============================================================================
sub copyExcelFile {
  # ftHgݒ
    my %default = (
        src  => '',                     # t@C
        dest => '',                     # Rs[t@C
        overwrite => $_G_Set{overwrite} # ㏑[h
    );
  
  # g󂯂Ƃ
    my $obj = shift(@_);
    
  # ͎w肳Ă?
    my %args = (%default, @_);
    if ($args{src} eq '') {
        $obj->error_msg("Argument 'src' is mandatory.");
        return undef;
    }
    
    if ($args{dest} eq '') {
        $obj->error_msg("Argument 'dest' is mandatory.");
        return undef;
    }
    
  # FileSystemObject擾
    my $objFso = Win32::OLE->new('Scripting.FileSystemObject');
  
  # Copy source file full path擾
    my $src_file_name_full = $objFso->GetAbsolutePathName($args{src});
    
  # srct@C͂?
    unless (-f $src_file_name_full) {
        $obj->error_msg("Source file '$src_file_name_full' is not found.");
        return undef;
    }
  
  # Copy destination file full path擾
    my $dest_file_name_full = $objFso->GetAbsolutePathName($args{dest});
  
  # ㏑֎~[hɃRs[t@CƂmF
    unless ($args{overwrite}) {
        if (-f $dest_file_name_full) {
            $obj->error_msg("Overwrite is disable but the dest file '$args{dest}' already exists.");
            return undef;
        }
    }
  
  # t@CRs[(Rs[g͋㏑[hŎ{)
  # FSO\bh̖߂l画f񓾂ꂸBExplorerdȂ?
    $objFso->CopyFile($src_file_name_full, $dest_file_name_full, 1);
  
  # I
    return 1;
}

# ==============================================================================
# openĂExcelt@Cʖsave
# ߂l: undef(s)/1() ߂lundef́uSaveΏۂvӖB
# ==============================================================================
sub saveAsExcelFile {
    my ($obj, $excel_file_name) = @_;
    
  # SaveΏۂBook Object擾
    my $book = get_book_obj($obj); return undef unless ($book);
  
  # t@CfullpXϊ
    my $objFso = Win32::OLE->new('Scripting.FileSystemObject');
    my $excel_file_name_full = $objFso->GetAbsolutePathName($excel_file_name);
    
  # t@C`FbN
  if (-f $excel_file_name_full) {
      unless ($_G_Set{overwrite}) {
          $obj->error_msg("Overwrite is disable but '$excel_file_name' alraedy exists.");
          return undef;
      }
      # Overwrite Enable̓t@C폜
      unlink($excel_file_name_full);
  }
  
  # Excel book saveAs\bh
    $book->SaveAs($excel_file_name_full);
  
  # IuWFNgTarget ExcelύX
    $obj->{excel_file_name} = $excel_file_name; # Excelt@C
    
  # I
    return 1;
}

# ==============================================================================
# openĂExcelt@Csave
# ߂l: undef(s)/1() ߂lundef́uSaveΏۂvӖB
# ==============================================================================
sub saveExcelFile {
    my ($obj) = @_;
    
  # SaveΏۂBook Object擾
    my $book = get_book_obj($obj); return undef unless ($book);
  
  # Excel save
    $book->Save();
    
  # I
    return 1;
}

# ==============================================================================
# Excelt@Cclose
# ߂l: undef(s)/1() ߂lundef́uCloseΏۂvӖB
# ==============================================================================
sub closeExcelFile {
    my ($obj) = @_;
    
  # CloseΏۂExcelt@CĂ?
    unless ($obj->{excel_file_name}) {
        $obj->error_msg("The instance does not have an excel spreadsheet to close.");
        return undef;
    }
    
  # CloseΏۂExcel ObjectĂ?
    unless ($obj->{obj_excel}) {
        $obj->error_msg("The instance does not have an opened excel object.");
        return undef;
    }
  
  # Excel objectI
    my $objExcel = $obj->{obj_excel};
    $objExcel->Quit();
    $obj->msg("Base file '$obj->{excel_file_name}' is closed.");
    
  # Objectyуoϐ
    object_init($obj);
    
  # I
    return 1;
}

# ==============================================================================
# Excelt@Copen
# ߂l: undef(s)/1()
# ==============================================================================
sub openExcelFile {
    my ($obj, $excel_file_name) = @_;
    
  # OpenĂt@C?
    unless ($obj->{excel_file_name} eq '') {
        $obj->error_msg("The instance has already opened '$obj->{excel_file_name}'.");
        return undef;
    }
    
  # wt@C͂?
    unless (-f $excel_file_name) {
        $obj->error_msg("Base file '$excel_file_name' is not found.");
        return undef;
    }
  
  # PCExcelg?
    my $objExcel = Win32::OLE->new('Excel.Application');
    unless ($objExcel) {
        $obj->error_msg("Excel OLE object has not been got. (Excel would not be installed.)");
        return undef;
    }
  
  # ExcelOpen͐΃pXKvȂ̂FSOGetAbsolutePathNameŕϊ
  # ̓G[
    my $objFso = Win32::OLE->new('Scripting.FileSystemObject');
    my $excel_file_name_full = $objFso->GetAbsolutePathName($excel_file_name);
    $objFso = undef; # FSO
    
  # wt@CExcelOpenł?
    my $objBook = $objExcel->Workbooks->Open($excel_file_name_full);
    unless ($objBook) {
        $obj->error_msg("Excel can not open '$excel_file_name'.");
        return undef;
    }
    $obj->msg("Base file '$excel_file_name' is opened.");
    
  # BookIuWFNg擾łAeoϐɓ
  # LoϐClassŎQƂ
    $obj->{excel_file_name} = $excel_file_name; # Excelt@C
    $obj->{obj_excel} = $objExcel;              # Excel Application
    $obj->{obj_book}  = $objBook;               # Excel Book
    
  # I
    return 1;
}

# ==============================================================================
# (Private)NamedRangẽV[g擾
# ߂l: undef(s) / V[g()
# ==============================================================================
sub get_name_sheet_of_named_range {
    my ($obj, $book, $name_range) = @_;
    
  # OtWZXg(\f[^Xg)擾
    my $cell_list_named_range = get_cell_list_of_named_range($obj, $book, $name_range);
    return undef unless ($cell_list_named_range);
    
  # CfbNX[0]\Ń[NV[go
    my $name_sheet = $cell_list_named_range->[0]->{sheet};
    $obj->msg("'$name_range' is defined in '$name_sheet'.");
  
  # V[g߂
    return $name_sheet;
}

# ==============================================================================
# NamedRangẽf[^vf擾
# ߂l: undef(s) / 1listt@X()
# ==============================================================================
sub getInfoNamedRange {
    my ($obj, $name_range) = @_;
    
    my $book = get_book_obj($obj); return undef unless($book);
    
    my $ret = get_cell_list_of_named_range($obj, $book, $name_range); return undef unless($ret);
    
    return $ret;
}

# ==============================================================================
# (Private)NamedRangẽZXg(\f[^Xg)擾
# ߂l: undef(s) / ZXgt@X()
# ==============================================================================
sub get_cell_list_of_named_range {
    my ($obj, $book, $name_range) = @_;
    
  # NamedRangeXgɎw背W݂͑?
    my $named_range_list = getListNamedRanges($obj);
    unless (grep {$_ eq $name_range} @{$named_range_list}) {
        $obj->error_msg("'sheet' arg is null but '$name_range' is not named range.");
        return undef;
    }
    $obj->msg("'$name_range' is named range.");
    
  # OtRangenameIuWFNg擾
    my $obj_named_range = $book->Names($name_range);
    
  # OtRangẽZ񃊃Xg(\f[^Xg)쐬
    my $cell_list_named_range = gen_named_range_cells($obj, $name_range, $obj_named_range);
    unless ($cell_list_named_range) {
        $obj->error_msg("Named range '$name_range' does not have any cell.");
        return undef;
    }
  
  # Xg߂
    return $cell_list_named_range;
}

# ==============================================================================
# (Private)OtZXgValueZXg쐬ăt@X߂
# ߂l: undef(s) / Xg(\f[^Xg)t@X()
# ==============================================================================
sub gen_named_range_cells {
    my ($obj, $name, $obj_range) = @_;
    
    my @list_range;
    my $idx = 0;
    
  # $obj_range->{Value}̓ZXgcsvA
    foreach my $buf0 ( split(/,/, $obj_range->{Value}) ) {
        my @list = split(/!/, $buf0);
        if ($#list >= 1) {
            $list[0] =~ s/^=//; # 擪=Ώ
            $list_range[$idx]->{sheet} = $list[0]; # V[g
            $list_range[$idx]->{range} = $list[1]; # W
            
            my $dim = get_dim_value_of_range($obj, $list_range[$idx]->{sheet}, $list_range[$idx]->{range});
            $list_range[$idx]->{row} = $dim->{r}; # sf[^
            $list_range[$idx]->{col} = $dim->{c}; # f[^
            $list_range[$idx]->{array} = $dim->{array}; # XJ[Xg
            
            my $msgstr = "${name}[$idx]: sheet=$list_range[$idx]->{sheet},";
               $msgstr .="range=$list_range[$idx]->{range},";
               $msgstr .="dim=\[$list_range[$idx]->{row},$list_range[$idx]->{col}\].";
            $obj->msg($msgstr);
            $idx++;
        }
    }
    
    return \@list_range;
}

# ==============================================================================
# (Private)Wl̃f[^^Cv߂
# ߂l: undef(s) / [1,0](XJ[), [max_r, max_c](2Xg)
# ==============================================================================
sub get_dim_value_of_range {
    my ($obj, $name_sheet, $name_range) = @_;
    my $type = undef;
    my %ret = (r=>0, c=>0);
    
  # RangeIuWFNg擾
    my $book  = get_book_obj($obj);
    my $sheet = get_sheet_obj($obj, $book, $name_sheet);
    my $range = get_range_obj($obj, $sheet, $name_range);
    
    my $value = $range->{Value};
    $type = getTypeVal($obj, $value);
    
    $obj->msg("Value type of $name_sheet!$name_range = $type.");
  
  # XJ[
    if ($type == 0) {
        $ret{r} = 0;
        $ret{c} = 0;
        $ret{array} = 0;
        return \%ret
    }
  
  # 2Xg
    $ret{r} = ($#{$range->{Value}}+1);
    $ret{c} = ($#{$range->{Value}->[0]}+1);
    $ret{array} = 1;
    return \%ret;
}

# ==============================================================================
# (Private)rangeIuWFNgL̊mFƎ擾
# ߂l: undef(s)/IuWFNgt@X()
# ==============================================================================
sub get_range_obj {
    my ($obj, $sheet, $name_range) = @_;
    
  # w肳ꂽRange͂?
    my $range = $sheet->Range($name_range);
    unless ($range) {
        $obj->error_msg("Range '$name_range' is not found.");
        return undef;
    }
    $obj->msg("Range '$name_range' is found.");
    
  # $range߂
    return $range;
}

# ==============================================================================
# (Private)SheetIuWFNgL̊mFƎ擾
# ߂l: undef(s)/IuWFNgt@X()
# ==============================================================================
sub get_sheet_obj {
    my ($obj, $book, $name_sheet) = @_;
    
  # w肳ꂽWorksheet͂?
    my $sheet = $book->Worksheets($name_sheet);
    unless ($sheet) {
        $obj->error_msg("Worksheet '$name_sheet' is not found.");
        return undef;
    }
    $obj->msg("Worksheet '$name_sheet' is found.");
    
  # $sheet߂
    return $sheet;
}

# ==============================================================================
# (Private)BookIuWFNgL̊mFƎ擾
# ߂l: undef(s)/IuWFNgt@X()
# ==============================================================================
sub get_book_obj {
    my ($obj) = @_;
    
  # BookOpenς?
    unless ($obj->{obj_book}) {
        $obj->error_msg("The instance doesn't have an excel book object.");
        return undef;
    }
    
  # $book߂
    return $obj->{obj_book};
}

# ==============================================================================
# (Private)Error\
# Module/ClassȂ̂ŁAG[\carp/croakg
# ==============================================================================
sub error_msg {
    my ($obj, $msg) = @_;
  
  # ړǉ
    $msg = "$obj->{class} ERR: ".$msg;
  
  # \yяI
    if ($_G_Set{warn} eq '3') {      # 3: bZ[W + croak
      # ̌croak/dieÎExcelIuWFNgΏI(vZXch~)
        $obj->{obj_excel}->Quit() if ($obj->{obj_excel});
        
      # ̌croakÎŃIuWFNg
        $obj->{excel_file_name} = undef;
        $obj->{class} = undef;
        $obj->{obj_book}  = undef if ($obj->{obj_book});
        $obj->{obj_excel} = undef if ($obj->{obj_excel});
        $obj = undef;
        
      # 3傫IvVݒdie(ClassJBIvV)
        die   $msg if ($_G_Set{warn} > 3); 
        
      # croak(die)ŃbZ[W\+I
        croak $msg;             # croakI
    } elsif ($_G_Set{warn} eq '2') { # 2: bZ[W + carp
        carp $msg;
    } elsif ($_G_Set{warn} eq '1') { # 1: bZ[W
        print STDERR $msg,"\n";
    }
}

# ==============================================================================
# (Private)Message\
# ==============================================================================
sub msg {
    my ($obj, $msg) = @_;
    
  # ړǉ
    $msg = "$obj->{class} MSG: ".$msg."\n";
    
  # \
    print $msg if ($_G_Set{msg} > 0);
}

# ==============================================================================
# (Private)fXgN^
# IɃIuWFNg(G[IΉ)
# ==============================================================================
sub DESTROY {
    my ($obj) = @_;
    
  # closeExcelFile()ŏIAExcelIuWFNgQuit(vZXch~)
    $obj->{obj_excel}->Quit() if ($obj->{obj_excel});
  
  # IuWFNg
    $obj->{excel_file_name} = undef;
    $obj->{class} = undef;
    $obj->{obj_book}  = undef if ($obj->{obj_book});
    $obj->{obj_excel} = undef if ($obj->{obj_excel});
    
    $obj = undef;
}

# ==============================================================================
# RXgN^
# ==============================================================================
sub new {
  # IuWFNg(nbVt@X)
    my $obj = {};
    
  # Class(Package)擾
    my $class = __PACKAGE__;
    
  # Class̓IuWFNgj܂ŉi
    $obj->{class} = $class;
    
  # IuWFNg
    object_init($obj);
    
  # $obj́uNXvɑ邱Ƃ錾
    bless $obj, $class;
  
  # Win32::OLEWarningxݒ
    Win32::OLE->Option(Warn => $_G_Set{warn_ole});
    
  # łIuWFNg߂
    return $obj;
}

# ==============================================================================
# NX̃IvVݒύX
# ==============================================================================
sub setOption {
  # g̃IuWFNg
    my $self = shift(@_);
    
  # Ot󂯎
    my %args = (%_G_Set, @_);
    
  # ʏ탁bZ[Wݒ
    $_G_Set{msg}  = $args{msg};
    
  # Warning/ErrorbZ[Wݒ
    $_G_Set{warn} = $args{warn};
  
  # Win32::OLE Warningݒ
    $_G_Set{warn_ole} = $args{warn_ole}; Win32::OLE->Option(Warn => $_G_Set{warn_ole});
  
  # File copy[hݒ
    $_G_Set{overwrite} = $args{overwrite};

}

# ==============================================================================
# (Private)IuWFNgoϐ
# ==============================================================================
sub object_init {
    my ($obj) = @_;
    
    $obj->{excel_file_name} = '';
    $obj->{obj_book}  = undef;
    $obj->{obj_excel} = undef;
}

# ==============================================================================

# requireΉ
1;
