@echo off
rem ############################################################
rem # batch file to run sample scripts of HandleOleExcel.pm
rem # revision 20230505a
rem ############################################################

:clean
    if exist "sample*.log"         del /Q "sample*.log"
    if exist "sample*_write.xlsx"  del /Q "sample*_write.xlsx"
    if exist "sample*_create.xlsx" del /Q "sample*_create.xlsx"
    
    if "%1"=="clean" (
        echo # ==========================================================
        echo # all output files are removed
        echo # ==========================================================
        goto exit_batch
    )


:set_run_samples
    if "%1"=="4"   ( call :run_sample4 )
    if "%1"=="3"   ( call :run_sample3 )
    if "%1"=="2"   ( call :run_sample2 )
    if "%1"=="1"   ( call :run_sample1 )
    if "%1"=="0"   ( call :run_sample0 )
    
    if "%1"==""    ( call :run_all_samples )
    if "%1"=="all" ( call :run_all_samples )
    
    goto exit_batch


:run_all_samples
    call :run_sample0
    call :run_sample1
    call :run_sample2
    call :run_sample3
    call :run_sample4
    exit /b


rem ############################################################
rem # followings are sample scripts
rem ############################################################

:run_sample4
    echo.
    echo # ==========================================================
    echo # sample4.pl : read sample4.xlsx
    echo # ==========================================================
    perl sample4.pl > sample4.log
    type sample4.log
    exit /b


:run_sample3
    echo.
    echo # ==========================================================
    echo # sample3.pl : create sample3_create.xlsx
    echo # ==========================================================
    perl sample3.pl > sample3.log
    type sample3.log
    exit /b


:run_sample2
    echo.
    echo # ==========================================================
    echo # sample2.pl : read sample2.xlsx  write sample2_write.xlsx
    echo # ==========================================================
    perl sample2.pl > sample2.log
    type sample2.log
    exit /b


:run_sample1
    echo.
    echo # ==========================================================
    echo # sample1.pl : read sample1.xlsx  write sample1_write.xlsx
    echo # ==========================================================
    perl sample1.pl > sample1.log
    type sample1.log
    exit /b


:run_sample0
    echo # ==========================================================
    echo # sample0.pl : read sample0.xlsx  write sample0_write.xlsx
    echo # ==========================================================
    perl sample0.pl > sample0.log
    type sample0.log
    exit /b


:exit_batch
    echo.
    echo Hit any key to quit...
    pause > nul
    exit /b

